## libgnatcoll 17.0.2017

=== Makefile ===
.PHONY: all examples test clean docs install generate_sources static relocatable shared

## Put this first so that it is the default make target
all:

include Makefile.conf

ifeq (${BUILDS_SHARED},yes)
# Additional targets. Builds relocatble first so that the tools are
# preferably linked statically.
all: relocatable static tools
install:  install-clean install_static \
		install_library_type/relocatable    \
		install_tools \
                install_gps_plugin
else
all: static tools
install:  install-clean install_static \
          install_tools \
          install_gps_plugin
endif

#######################################################################
#  build

## Builds explicitly the shared or the static libraries

static-pic: build_library_type/static-pic

tools: build_tools/static
install_tools: install_tools/static

ifeq (${BUILDS_STATIC_PIC},yes)
static: build_library_type/static build_library_type/static-pic
install_static: install_library_type/static \
                install_library_type/static-pic
else
static: build_library_type/static
install_static: install_library_type/static
endif

shared relocatable: build_library_type/relocatable

# Build either type of library. The argument (%) is the type of library to build

GPRBLD_OPTS=-p -m -j${PROCESSORS} -XLIBRARY_TYPE=$(@F) -XGnatcoll_Build=${Gnatcoll_Build} -XXMLADA_BUILD=$(@F)

build_library_type/%: generate_sources
	@${RM} src/gnatcoll-atomic.adb

	@echo "====== Building $(@F) libraries ======"
	${GPRBUILD} ${GPRBLD_OPTS} -Pgnatcoll_full

	@# Need to build libgnatcoll_gtk separately, because its project files
	@# requires gtkada.gpr, which might not exist on the machine.
ifeq (${WITH_GTK},yes)
	${GPRBUILD} ${GPRBLD_OPTS} -Psrc/gnatcoll_gtk
endif

build_tools/%: build_library_type/%
	@echo "====== Building $(@F) tools ======"
	@# Build the tools (the list is the project\'s Main attribute)
	@# They are not build as part of the above because only the Main from
	@# gnatcoll_full.gpr are build. We could use aggregate projects to
	@# speed things up.
	${GPRBUILD} ${GPRBLD_OPTS} -q -Psrc/gnatcoll_tools

#######################################################################
#  install

GPRINST_OPTS=-p -f --prefix=${prefix} --install-name=gnatcoll \
	--exec-subdir=${bindir} --project-subdir=lib/gnat -XXMLADA_BUILD=$(@F) \
	--build-var=LIBRARY_TYPE --build-name=$(@F) -XLIBRARY_TYPE=$(@F)

install-clean:
ifneq (,$(wildcard $(prefix)/lib/gnat/manifests/gnatcoll))
	-$(GPRINSTALL) --uninstall -f \
		--prefix=$(prefix) --project-subdir=lib/gnat gnatcoll
endif


install_library_type/%:
	@echo "====== Installing $(@F) libraries ======"
	${GPRINSTALL} -r ${GPRINST_OPTS} -Pgnatcoll_full
ifeq (${WITH_GTK},yes)
	${GPRINSTALL} ${GPRINST_OPTS} -Psrc/gnatcoll_gtk
endif

install_tools/%:
	@echo "====== Installing $(@F) tools ======"
	${GPRINSTALL} --mode=usage ${GPRINST_OPTS} -Psrc/gnatcoll_tools

install_gps_plugin: force
	mkdir -p $(prefix)/share/gps/plug-ins
	-(cd distrib/ ; python ./gen_gps.py)
	(cd distrib/; tar cf - gnatcoll) | \
          (cd $(prefix)/share/gps/plug-ins ; tar xf -)

# Regenerate part of the sources. Unfortunately, this can be run only after
# we have build GNATCOLL, and then its tools, even though GNATCOLL itself
# relies on those generated sources.
# So this target simply does nothing if gnatcoll_db2ada is not found, in which
# case we use the checked in sources (which means that changing the dbschema
# requires to have already built GNATCOLL once before).

generate_sources:
	-@if [ -f src/obj/gnatcoll_db2ada${EXE} ]; then \
	   src/obj/gnatcoll_db2ada${EXE} -dbtype=sqlite -dbname=:memory: \
		-output src/xref.generated \
		-dbmodel=src/dbschema.txt \
		-createdb \
		-adacreate \
		-api GNATCOLL.Xref.Database \
		-load=src/initialdata.txt \
		-enum "f2f_kind,id,name,F2F,Integer" \
		-enum "e2e_kind,id,name,E2E,Integer"; \
	   for f in src/xref.generated/*.ad?; do \
	      tr -d '\r' < $$f > $$f.tmp && mv $$f.tmp $$f; \
	   done; \
	fi

examples:
	${MAKE} -C examples all

SQLITE_DIR=src/sqlite/amalgamation
sqlite3_shell: $(SQLITE_DIR)/sqlite3_for_gps
$(SQLITE_DIR)/sqlite3_for_gps: $(SQLITE_DIR)/shell.c $(SQLITE_DIR)/sqlite3.c
ifeq ($(OS),Windows_NT)
	-cd $(SQLITE_DIR); gcc -O2 -DSQLITE_OMIT_LOAD_EXTENSION -D__EXTENSIONS__ -o sqlite3_for_gps shell.c sqlite3.c
else
	# If we fail to compile, never mind. Some tests will simply be disabled
	-cd $(SQLITE_DIR); gcc -O2 -DSQLITE_OMIT_LOAD_EXTENSION -D__EXTENSIONS__ -o sqlite3_for_gps shell.c sqlite3.c -lpthread -ldl
endif

## Only works after installation, so we should install to a local directory
## first, so as not to break the users's environment, but still test the
## actual installation process.
## However, we do not force a recompilation here for now, so that we can still
## run the tests on the current binaries, even if we are doing some modifs
## that are not yet compilable
test_names=

local_install: force
	@${MAKE} prefix=${shell pwd}/local_install install >/dev/null

test: sqlite3_shell local_install
	@${MAKE} test_names="${test_names}" -C testsuite

test_verbose: local_install
	@${MAKE} test_names="${test_names}" -C testsuite verbose

#######################################################################
#  clean

## Clean either type of library, based on the value of (%)

GPRCLN_OPTS=-r -q -XLIBRARY_TYPE=$(@F)

clean_library/%:
	-gprclean ${GPRCLN_OPTS} -Pgnatcoll_full
	@# Separate pass to also remove the Main
	-gprclean ${GPRCLN_OPTS} -Psrc/gnatcoll_tools
ifeq (${WITH_GTK},yes)
	-gprclean ${GPRCLN_OPTS} -Psrc/gnatcoll_gtk
endif

clean: clean_library/static clean_library/static-pic clean_library/relocatable
	-${MAKE} -C testsuite $@
	-${MAKE} -C docs $@
	-${MAKE} -C examples $@

docs:
	${MAKE} -C docs html latexpdf

force:

=== examples/Makefile ===
all:
include ../Makefile.conf

ADA_PROJECT_PATH:=${prefix}/lib/gnat${DIRSEP}${ADA_PROJECT_PATH}${DIRSEP}../src
LD_LIBRARY_PATH:=${prefix}/lib:${LD_LIBRARY_PATH}
export ADA_PROJECT_PATH
export LD_LIBRARY_PATH

all:
	gnatmake -p -Pexamples
ifeq ($(WITH_GTK),yes)
	gprbuild -p -Pexamplesgtk
endif
ifeq ($(WITH_GMP),yes)
	gprbuild -p -Pgmp/gmp_examples.gpr
endif
	@echo "==================================================="
	@echo "== To run, set the environment variable LD_LIBRARY_PATH"
	@echo "==   LD_LIBRARY_PATH=${prefix}/lib/gnat:\$$LD_LIBRARY_PATH"

clean:
	-gprclean -q -Pexamples
ifeq ($(WITH_GTK),yes)
	-gprclean -q -Pexamplesgtk
endif
ifeq ($(WITH_GMP),yes)
	-gprclean -q -Pgmp/gmp_examples.gpr
endif

=== testsuite/Makefile ===
test:
include ../Makefile.conf

# ADA_PROJECT_PATH:=${prefix}/lib/gnat${DIRSEP}${ADA_PROJECT_PATH}${DIRSEP}../src
# LD_LIBRARY_PATH:=${prefix}/lib:${LD_LIBRARY_PATH}
# export ADA_PROJECT_PATH
# export LD_LIBRARY_PATH

test_names=

test:
	@python ./run.py ${test_names}

test_local:
	@python ./run.py --local ${test_names}

verbose:
	@python ./run.py -v -v ${test_names}

clean:

=== testsuite/json/P401-004/Makefile ===
default: build

build:
	gprbuild -m -s -Xosx_support_atos=on -P example.gpr

clean:
	gnat clean -P example.gpr

test: build
	bash testit.sh

=== debian/changelog ===
libgnatcoll (17.0.2017-3) unstable; urgency=medium

  * Make testsuite more verbose. Closes: #872081.
  * Build-Depend latexmk for LaTeX sphinx-doc module. Closes: #872204.
  * Build-Depend: python3 version of sphinx-doc. Patch conf.py.
  * Standards-Version: 4.1.0.
  * Rebuild with libgpr 2017-5 (because of libxmlada-unicode).
    -dev version is already new in testing.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 26 Sep 2017 16:54:43 +0200

libgnatcoll (17.0.2017-2) unstable; urgency=medium

  * Upload to unstable.
  * The switch to gcc-7 requires a SO version bump for each library,
    except gnatcoll, g-python, g-xref, already new in unstable.
    The Break/Replace with previous -dev becomes implicit in unstable.
  * Disable parallel doc generation to prevent #869098.
  * Standards-Version: 4.0.1. Priority: optional.
  * Vcs-Mtn: new URI format.
  * clean objects forgotten by aclocal.m4.
  * Build-Depends: renamed texlive-plain-generic.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 10 Aug 2017 12:42:17 +0200

libgnatcoll (17.0.2017-1) experimental; urgency=medium

  * New upstream release, two new packages for the gnatcoll-xref library.
    No ALI/SO bump in experimental.
  * Build with gnat-7, which deals with SOURCE_DATE_EPOCH directly.
  * Debhelper 10, which deals with autoconf generated stuff.
  * Standards-Version: 4.0.0. Downgrade -doc to Suggests.
    HTTPS URL for copyright format. Handle DEB_BUILD_OPTIONS=nodoc.
  * Allow -doc package to satisfy multi-arch foreign dependencies.
  * PDFLatex now handles SOURCE_DATE_EPOCH without faketime.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 11 Jul 2017 01:44:33 +0200

libgnatcoll (16.1.0-1) experimental; urgency=medium

  * New upstream release. Update to ligtkada16.1.0-dev.
    Replace libgnatprj/vsn, dropped by GCC with libgpr from gprbuild.
    Bump ALI versions and conflict/break previous -dev per Ada policy.
    Bump SO versions for gnatcoll and gnatcoll-python.
  * Remove many patches to upstream Makefile and invoke gprbuild directly.
    Upstream prefers a reduced set of well tested configurations.
  * remove generate-sources-timestamp.diff, but regenerate the sources after
    the build and fail if they differ with the ones from the tarball.
  * python_single_statement_set_default_console.diff was waiting an ALI bump.
  * Select all hardening flags, gprbuild will override pie when needed.
  * C sources, ignored in ALI files, do not require predictible timestamps.
  * Simplify watch file thanks to version 4 format.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 21 Aug 2016 17:48:30 +0200

=== debian/control ===
Source: libgnatcoll
Priority: optional
Section: misc
Maintainer: Nicolas Boulenguez <nicolas@debian.org>
Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 10),
 gnat, gnat-7,
# This line is parsed by d/rules.
# dh-ada-library allowing .ada extension.
 dh-ada-library (>= 6.10),
# gprbuild cleaning auto.cgpr.
 gprbuild (>= 2017),
 libgpr1-dev (>= 2017-5),
# Implicit libc6-dev provides: iconv, syslog.
 libgmp-dev,
 libgtkada16.1.0-dev, pkg-config, python-gi-dev,
 python-dev, libpython-dev,
 libreadline-dev,
 libsqlite3-dev
Build-Depends-Indep:
# Formatting (python3-sphinx is experimental)
 python3-sphinx,
 latexmk,
# Sphinx >= 1.6 uses the latexmk driver.
 texlive-fonts-recommended,
# sphinx-doc requires iftex.sty:
 texlive-plain-generic,
 texlive-latex-extra
# dh_sphinxdoc
 ,sphinx-common
Homepage: http://libre.adacore.com/libre/tools
Standards-Version: 4.1.0
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libgnatcoll
Vcs-Mtn: mtn://www.ada-france.org?org.debian.libgnatcoll

Package: libgnatcoll16.1.0-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Suggests: libgnatcoll-doc
Description: GNATColl, general purpose Ada library
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the static library and Ada specifications.

Package: libgnatcoll-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Suggests: gnat
Description: GNATColl, general purpose Ada library (documentation)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the documentation in text, PDF and HTML.

Package: libgnatcoll16.1.0
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: GNATColl, general purpose Ada library (runtime)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the runtime shared library.

######################################################################

Package: libgnatcoll-python16.1.0-dev
Section: libdevel
Architecture: any
Depends: libpython-dev, ${misc:Depends}, ${ada:Depends}
Suggests: libgnatcoll-doc
Description: GNATColl, general purpose Ada library (Python)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the static library and Ada specifications
 adding Python as scripting language.

Package: libgnatcoll-python16.1.0
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: GNATColl, general purpose Ada library (Python runtime)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the runtime shared library for Python
 scripting.

######################################################################

Package: libgnatcoll-iconv16.1.0-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Suggests: libgnatcoll-doc
Description: GNATColl, general purpose Ada library (iconv)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the static library and Ada specifications
 for the binding with the Iconv C library.

Package: libgnatcoll-iconv17.0.2017
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: GNATColl, general purpose Ada library (iconv runtime)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the runtime shared library for the iconv
 binding.

######################################################################

Package: libgnatcoll-sqlite16.1.0-dev
Section: libdevel
Architecture: any
Depends: libsqlite3-dev, ${misc:Depends}, ${ada:Depends}
Suggests: libgnatcoll-doc
Description: GNATColl, general purpose Ada library (SQLite)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the static library and Ada specifications
 dedicated to SQLite databases manipulation.

Package: libgnatcoll-sqlite17.0.2017
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: GNATColl, general purpose Ada library (sqlite runtime)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the runtime shared library for the SQLite
 extension.

Package: libgnatcoll-sqlite-bin
Section: devel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
# gnat-gps used to provide gnatinspect.
Breaks: gnat-gps (<< 5.3-4)
Replaces: gnat-gps (<< 5.3-4)
Suggests: libgnatcoll-doc
Description: GNATColl, general purpose Ada library (SQLite tools)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the tools dedicated to SQLite database
 manipulation (gnatcoll_db2ada and gnatinspect).

######################################################################

Package: libgnatcoll-readline16.1.0-dev
Section: libdevel
Architecture: any
Depends: libreadline-dev, ${misc:Depends}, ${ada:Depends}
Suggests: libgnatcoll-doc
Description: GNATColl, general purpose Ada library (readline)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the static library and Ada specifications
 for the binding with GNU readline and history libraries.

Package: libgnatcoll-readline17.0.2017
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: GNATColl, general purpose Ada library (readline runtime)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the runtime shared library for the readline
 binding.

######################################################################

Package: libgnatcoll-gmp16.1.0-dev
Section: libdevel
Architecture: any
Depends: libgmp-dev, ${misc:Depends}, ${ada:Depends}
Suggests: libgnatcoll-doc
Description: GNATColl, general purpose Ada library (GMP)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the static library and Ada specifications
 for the binding with the GNU Multiprecision arithmetic C library.

Package: libgnatcoll-gmp17.0.2017
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: GNATColl, general purpose Ada library (GMP runtime)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the runtime shared library for the GMP binding.

######################################################################

Package: libgnatcoll-gtk16.1.0-dev
Section: libdevel
Architecture: any
Depends: python-gi-dev, ${misc:Depends}, ${ada:Depends}
Suggests: libgnatcoll-doc
Description: GNATColl, general purpose Ada library (GTKAda)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the static library and Ada specifications
 for the GTKAda extension.

Package: libgnatcoll-gtk17.0.2017
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: GNATColl, general purpose Ada library (GTKAda runtime)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the runtime shared library for the GTKAda
 extension.

######################################################################

Package: libgnatcoll-xref17.0.2017-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Suggests: libgnatcoll-doc
Description: GNATColl, general purpose Ada library (XRef)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the static library and Ada specifications
 for the XRef extension.

Package: libgnatcoll-xref17.0.2017

=== debian/rules ===
#!/usr/bin/make -f
# Build script for GNATColl in Debian.
# Copyright (c) 2014-2017 Nicolas Boulenguez <nicolas@debian.org>

# This build script is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
# USA

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

projects :=
versions :=
$(foreach line,$(shell sed -n '\
  s/^ gnat, gnat-\([0-9.]\+\),$$/GNAT_VERSION:=\1/p; \
  /^Package: lib\([a-z-]\+\)\([0-9.]\+\(gpl[0-9]\{4\}\)\?\)$$/ { \
    s~~projects+=src/\1.gpr versions+=\U\1\E_VERSION=\2~; \
    y/-/_/; \
    p; \
  }; \
  ' debian/control),$(eval $(line)))

DEB_BUILD_MAINT_OPTIONS := hardening=+all
include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk

%:
	dh $@ --with ada-library

override_dh_auto_configure:
  # Patch version number for documentation.
	dh_auto_configure -- \
	  --enable-gpl \
	  --enable-shared \
	  --enable-shared-python \
	  PACKAGE_VERSION=$(DEB_VERSION_UPSTREAM) \
	  $(foreach v,CC CFLAGS CPPFLAGS LDFLAGS,"$(v)=$($(v))") \
	  --without-postgresql \
	  --with-sqlite=/usr/include/$(DEB_HOST_MULTIARCH)

# Ignore upstream build system.
.PHONY: $(addprefix override_dh_auto_, \
 configure build-arch build-indep test install clean)

# Upstream insists on setting the -j option inside projects.
BUILDER_OPTIONS := $(patsubst -j%,-XPROCESSORS=%,$(BUILDER_OPTIONS))

# Upstream insists on unpredictable directories.
BUILDER_OPTIONS += -p

# See patches/compilation_options.diff
BUILDER_OPTIONS += \
  $(foreach v,ADAFLAGS CFLAGS CPPFLAGS LDFLAGS,"-X$(v)=$($(v))")

# patches/library_versions.diff
BUILDER_OPTIONS += $(addprefix -X,$(versions))

xref_generated := src/xref.generated

override_dh_auto_build-arch:
 # Copy upstream's Makefile, but do not build tools twice.
 # Also, do not randomly regenerate the sources.
	gprbuild gnatcoll_full.gpr -XLIBRARY_TYPE=static $(BUILDER_OPTIONS)
	gprbuild src/gnatcoll_gtk.gpr -XLIBRARY_TYPE=static $(BUILDER_OPTIONS)
	gprbuild gnatcoll_full.gpr $(BUILDER_OPTIONS)
	gprbuild src/gnatcoll_gtk.gpr $(BUILDER_OPTIONS)
	gprbuild src/gnatcoll_tools.gpr $(BUILDER_OPTIONS)
 # I see no sensible way to recreate the xref sources without depending
 # on a previous libgnatcoll-sqlite-bin and causing bootstrap
 # problems.  At least let the build fail if the generated sources
 # differ, probably because the schema has been modified.
	mv $(xref_generated) $(xref_generated).bak
	mkdir $(xref_generated)
	LD_LIBRARY_PATH=src/lib/gnatcoll/relocatable:src/lib/iconv/relocatable:src/lib/sqlite/relocatable \
	$(MAKE) generate_sources
 # If a difference is found, fail and display it.
	diff -urN $(xref_generated).bak $(xref_generated)
 # Keep the version with the correct timestamps.
	rm -fr $(xref_generated)
	mv $(xref_generated).bak $(xref_generated)

# Upstream docs target does not generate text output.
override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
  # TODO: append SPHINXOPTS=-j$(BUILDER_JOBS) once #869098 is fixed.
	$(MAKE) -C docs html latexpdf text
endif

# Default dh_auto_clean would test -f Makefile.
# distclean target is added by a Debian patch.
# Gprclean ignores shared object versions, remove the whole directory.
override_dh_auto_clean::
	if test -f Makefile.conf; then $(MAKE) clean distclean; fi
	rm -fr src/lib

.PHONY: override_dh_clean
override_dh_clean:
	dh_clean --exclude=testsuite/xref/F516-004/default.gpr.orig

# Check dependencies across -dev packages (or generated projects)
# after any change in the structure of upstream projects.
.PHONY: override_dh_ada_library-arch override_dh_ada_library-indep
override_dh_ada_library-arch:
	dh_ada_library --arch $(foreach p,$(projects),$(versions) $(p))

# Mimic 'dh --with sphinxdoc', but without adding sphinx-common to
# Build-Depends for arch-only builds.
.PHONY: override_dh_installdocs-indep
override_dh_installdocs-indep:
	dh_installdocs -i
	dh_sphinxdoc

.PHONY: override_dh_compress
override_dh_compress:
	dh_compress --package=libgnatcoll-doc --exclude=.adb --exclude=.ads
	dh_compress --remaining-packages

=== debian/tests/control ===
Tests: examples projects
Depends: @, gprbuild

=== debian/watch ===
version=4

opts=\
  repack,\
  compression=xz,\
  filenamemangle=s/^.*download=//,\
  dversionmangle=s/^.*\.// \
https://qa.debian.org/cgi-bin/fakeupstream.cgi?upstream=adacore/gnatcoll \
.*gnatcoll-gpl@ANY_VERSION@-src@ARCHIVE_EXT@

# Major and minor versions are set manually, see README.source.

## libgnatcoll 18

=== Makefile ===
##############################################################################
##                                                                          ##
##                              GNATCOLL LIBRARY                            ##
##                                                                          ##
##                         Copyright (C) 2017, AdaCore.                     ##
##                                                                          ##
## This library is free software;  you can redistribute it and/or modify it ##
## under terms of the  GNU General Public License  as published by the Free ##
## Software  Foundation;  either version 3,  or (at your  option) any later ##
## version. This library is distributed in the hope that it will be useful, ##
## but WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHAN# ##
## TABILITY or FITNESS FOR A PARTICULAR PURPOSE.                            ##
##                                                                          ##
## As a special exception under Section 7 of GPL version 3, you are granted ##
## additional permissions described in the GCC Runtime Library Exception,   ##
## version 3.1, as published by the Free Software Foundation.               ##
##                                                                          ##
## You should have received a copy of the GNU General Public License and    ##
## a copy of the GCC Runtime Library Exception along with this program;     ##
## see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see    ##
## <http://www.gnu.org/licenses/>.                                          ##
##                                                                          ##
##############################################################################

# Makefile targets
# ----------------
#
# Setup:                   make [VAR=VALUE] setup (see below)
# Build:                   make
# Install:                 make install

# Variables which can be set:
#
# General:
#
#   prefix        : root install directory
#   ENABLE_SHARED : yes / no (or empty)
#   BUILD         : DEBUG PROD
#   PROCESSORS    : nb parallel compilations (0 to use all cores)
#   TARGET        : target triplet for cross-compilation
#   INTEGRATED    : installs the project as part of the compiler installation;
#                   this adds NORMALIZED_TARGET subdir to prefix
#
# Project specific:
#
#   GNATCOLL_MMAP    : whether MMAP is supported (yes/no)
#                      default is "yes"; has no effect on Windows
#   GNATCOLL_MADVISE : whether MADVISE is supported (yes/no)
#                      default is "yes"; has no effect on Windows
#   GNATCOLL_ATOMICS : atomic model (intrinsic/mutex)
#                      default is "intrinsic"

# helper programs
CAT := cat
ECHO  := echo
WHICH := which

# check for out-of-tree build
SOURCE_DIR := $(dir $(MAKEFILE_LIST))
ifeq ($(SOURCE_DIR),./)
  RBD=
  GNATCOLL_GPR=gnatcoll.gpr
  MAKEPREFIX=
else
  RBD=--relocate-build-tree
  GNATCOLL_GPR=$(SOURCE_DIR)/gnatcoll.gpr
  MAKEPREFIX=$(SOURCE_DIR)/
endif

TARGET := $(shell gcc -dumpmachine)
NORMALIZED_TARGET := $(subst normalized_target:,,$(wordlist 6,6,$(shell gprconfig  --config=ada --target=$(TARGET) --mi-show-compilers)))
ifeq ($(NORMALIZED_TARGET),)
  $(error No toolchain found for target "$(TARGET)")
endif

GNATCOLL_OS := $(if $(findstring darwin,$(NORMALIZED_TARGET)),osx,$(if $(findstring windows,$(NORMALIZED_TARGET)),windows,unix))

prefix := $(dir $(shell $(WHICH) gnatls))..
GNATCOLL_VERSION := $(shell $(CAT) $(SOURCE_DIR)/version_information)
GNATCOLL_MMAP := yes
GNATCOLL_MADVISE := yes
GNATCOLL_ATOMICS := intrinsic

BUILD         = PROD
PROCESSORS    = 0
BUILD_DIR     =
ENABLE_SHARED = yes
INTEGRATED    = no

all: build

# Load current setup if any
-include makefile.setup

GTARGET=--target=$(NORMALIZED_TARGET)

ifeq ($(ENABLE_SHARED), yes)
   LIBRARY_TYPES=static relocatable static-pic
else
   LIBRARY_TYPES=static
endif

ifeq ($(INTEGRATED), yes)
   integrated_install=/$(NORMALIZED_TARGET)
endif


GPR_VARS=-XGNATCOLL_MMAP=$(GNATCOLL_MMAP) \
	 -XGNATCOLL_MADVISE=$(GNATCOLL_MADVISE) \
	 -XGNATCOLL_ATOMICS=$(GNATCOLL_ATOMICS) \
	 -XGNATCOLL_VERSION=$(GNATCOLL_VERSION) \
	 -XGNATCOLL_OS=$(GNATCOLL_OS) \
	 -XBUILD=$(BUILD)

# Used to pass extra options to GPRBUILD, like -d for instance
GPRBUILD_OPTIONS=

BUILDER=gprbuild -p -m $(GTARGET) $(RBD) -j$(PROCESSORS) $(GPR_VARS) \
	$(GPRBUILD_OPTIONS)
INSTALLER=gprinstall -p -f $(GTARGET) $(GPR_VARS) \
	$(RBD) --sources-subdir=include/gnatcoll --prefix=$(prefix)$(integrated_install)
CLEANER=gprclean -q $(RBD) $(GTARGET)
UNINSTALLER=$(INSTALLER) -p -f --install-name=gnatcoll --uninstall

#########
# build #
#########

build: $(LIBRARY_TYPES:%=build-%)

build-%:
	$(BUILDER) -XLIBRARY_TYPE=$* -XXMLADA_BUILD=$* -XGPR_BUILD=$* \
		$(GPR_VARS) $(GNATCOLL_GPR)

###########
# Install #
###########

uninstall:
ifneq (,$(wildcard $(prefix)$(integrated_install)/share/gpr/manifests/gnatcoll))
	$(UNINSTALLER) $(GNATCOLL_GPR)
endif

install: uninstall $(LIBRARY_TYPES:%=install-%)

install-%:
	$(INSTALLER) -XLIBRARY_TYPE=$* -XXMLADA_BUILD=$* -XGPR_BUILD=$* \
		--build-name=$* $(GPR_VARS) \
		--build-var=LIBRARY_TYPE --build-var=GNATCOLL_BUILD \
		--build-var=GNATCOLL_CORE_BUILD $(GNATCOLL_GPR)

###########
# Cleanup #
###########

clean: $(LIBRARY_TYPES:%=clean-%)

clean-%:
	-$(CLEANER) -XLIBRARY_TYPE=$* -XXMLADA_BUILD=$* -XGPR_BUILD=$* \
		$(GPR_VARS) $(GNATCOLL_GPR)

#########
# setup #
#########

.SILENT: setup

setup:
	$(ECHO) "prefix=$(prefix)" > makefile.setup
	$(ECHO) "ENABLE_SHARED=$(ENABLE_SHARED)" >> makefile.setup
	$(ECHO) "INTEGRATED=$(INTEGRATED)" >> makefile.setup
	$(ECHO) "BUILD=$(BUILD)" >> makefile.setup
	$(ECHO) "PROCESSORS=$(PROCESSORS)" >> makefile.setup
	$(ECHO) "TARGET=$(TARGET)" >> makefile.setup
	$(ECHO) "SOURCE_DIR=$(SOURCE_DIR)" >> makefile.setup
	$(ECHO) "GNATCOLL_OS=$(GNATCOLL_OS)" >> makefile.setup
	$(ECHO) "GNATCOLL_VERSION=$(GNATCOLL_VERSION)" >> makefile.setup
	$(ECHO) "GNATCOLL_MMAP=$(GNATCOLL_MMAP)" >> makefile.setup
	$(ECHO) "GNATCOLL_MADVISE=$(GNATCOLL_MADVISE)" >> makefile.setup
	$(ECHO) "GNATCOLL_ATOMICS=$(GNATCOLL_ATOMICS)" >> makefile.setup

# Let gprbuild handle parallelisation. In general, we don't support parallel
# runs in this Makefile, as concurrent gprinstall processes may crash.
.NOTPARALLEL:

=== examples/Makefile ===
--- 
+++ 
@@ -8,9 +8,6 @@
 
 all:
 	gnatmake -p -Pexamples
-ifeq ($(WITH_GTK),yes)
-	gprbuild -p -Pexamplesgtk
-endif
 ifeq ($(WITH_GMP),yes)
 	gprbuild -p -Pgmp/gmp_examples.gpr
 endif
@@ -20,9 +17,6 @@
 
 clean:
 	-gprclean -q -Pexamples
-ifeq ($(WITH_GTK),yes)
-	-gprclean -q -Pexamplesgtk
-endif
 ifeq ($(WITH_GMP),yes)
 	-gprclean -q -Pgmp/gmp_examples.gpr
 endif

=== debian/changelog ===
libgnatcoll (18-4) unstable; urgency=medium

  * Debhelper 12. No need for d/compat anymore.
  * Standards-Version: 4.3.0.

  [ Dmitry Shachnev <mitya57@debian.org> ]
  * Remove unused and obsolete pngmath sphinx extension. Closes: #918816.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 09 Jan 2019 19:04:22 +0100

libgnatcoll (18-3) unstable; urgency=medium

  * The binary packages were introduced by the gnat-8 transition (#908931),
    but appear as new in unstable because of the two FTBS below.
  * Prevent Makefile from messing with gprconfig. Fixes i386, hurd-i386.
  * Depend gprbuild >= 2018-3. Fixes static archive on most architectures.
  * Standards-Version: 4.2.1. Rules-Requires-Root: no.
  * More checks in link options.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 01 Nov 2018 18:02:17 +0100

libgnatcoll (18-2) unstable; urgency=medium

  * Rebuild in unstable for gnat-8 transition.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 27 Oct 2018 15:09:56 +0200

libgnatcoll (18-1) experimental; urgency=medium

  * New upstream release, splitting former libgnatcoll source package.
    Some components move to libgnatcoll-bindings or libgnatcoll-db.
  * Remove more unwanted files.
  * Add previously forgotten copyright for getRSS.c.
  * Fix path to documentation in gps xml registration.
  * Link with libdl to fix a build failure.
  * Enable parallel build of documentation, #869098 is fixed.

 -- Nicolas Boulenguez <nicolas@debian.org>  Fri, 22 Jun 2018 22:42:23 +0200

libgnatcoll (17.0.2017-5) experimental; urgency=medium

  * Rebuild with gnat-8, libgpr1-dev, libgtkada18-dev..
    Rename shared libraries and -dev packages per Debian Ada policy.
  * Remove watch file. Explain why in README.source.
  * Install documentation to libgnatcoll-doc.
    Doc is shared for all -dev packages, so the effort is wasted.
  * Remove override for lintian pedantic messages.
  * Update upstream home page.
  * Use forgotten sphinxdoc:Built-Using substitution variable.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 08 May 2018 08:13:15 +0200

libgnatcoll (17.0.2017-4) unstable; urgency=medium

  * Upload to unstable.
  * Break+Replace: previous gtkada-dev package per Ada policy. Closes: #896570.
  * Standards-Version: 4.1.4.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 24 Apr 2018 17:17:56 +0200

libgnatcoll (17.0.2017-4~pre1) experimental; urgency=medium

  * Rebuild with libgtkada-dev updating gtk-gir, fixing gnat-gps.
    Ada policy requires a renaming of the libgnatcoll-gtk-dev package,
    but the fix does not affect the gnatcoll ABI and SO version.
  * Debhelper 11 and Standards-Version: 4.1.3.
    Move docs from /u/s/doc/*-doc to /u/s/doc/*-dev.
  * Build-Depends: drop obsolete version restriction on dpkg-dev.
  * python_single_statement_set_default_console.diff: fix serious typo.
  * Build-Depend: drop dpkg-dev obsolete version restriction.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 03 Mar 2018 14:28:59 +0100

=== debian/control ===
Source: libgnatcoll
Priority: optional
Section: misc
Maintainer: Nicolas Boulenguez <nicolas@debian.org>
Build-Depends:
 debhelper-compat (= 12),
 gnat, gnat-8,
# This line is parsed to set gnat version.
# dh-ada-library allowing .ada extension.
 dh-ada-library (>= 6.10),
# gprbuild building static libraries.
 gprbuild (>= 2018-3),
 libgpr2-dev (>= 2017-5),
# Implicit libc6-dev provides: iconv, syslog.
Build-Depends-Indep:
 python3-sphinx,
 latexmk,
# Sphinx >= 1.6 uses the latexmk driver.
 texlive-fonts-recommended,
# sphinx-doc requires iftex.sty:
 texlive-plain-generic,
 texlive-latex-extra
# dh_sphinxdoc
 ,sphinx-common
Homepage: https://www.adacore.com/community
Standards-Version: 4.3.0
Rules-Requires-Root: no
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libgnatcoll
Vcs-Mtn: mtn://www.ada-france.org?org.debian.libgnatcoll

Package: libgnatcoll17-dev
# Such lines are parsed to set Ada Library Information versions.
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Suggests: libgnatcoll-doc
Description: GNATColl, general purpose Ada library
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the static library and Ada specifications.

Package: libgnatcoll-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Built-Using: ${sphinxdoc:Built-Using}
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Suggests: gnat
Description: GNATColl, general purpose Ada library (documentation)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the documentation in text, PDF and HTML.

Package: libgnatcoll17
# Such lines are parsed to set Shared Object versions.
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: GNATColl, general purpose Ada library (runtime)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the runtime shared library.

=== debian/rules ===
#!/usr/bin/make -f
# Build script for GNATColl in Debian.
# Copyright (c) 2014-2018 Nicolas Boulenguez <nicolas@debian.org>

# This build script is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

$(foreach line,$(shell sed -n '\
  s/^ gnat, gnat-\([0-9.]\+\),$$/GNAT_VERSION:=\1/p; \
  s/^Package: libgnatcoll\([0-9.]\+\)$$/GNATCOLL_VERSION:=\1/p; \
  ' debian/control),$(eval $(line)))

DEB_BUILD_MAINT_OPTIONS := hardening=+all
DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed -Wl,--no-undefined \
  -Wl,--no-copy-dt-needed-entries -Wl,--no-allow-shlib-undefined
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk

%:
	dh $@ --with ada-library

.PHONY: override_dh_auto_clean
# We can do better than gprclean.

# static and relocatable, but not static-pic
# Prevent Makefile from messing with gprconfig
# (NORMALIZED_TARGET is wrong at least for i386 and hurd-i386).
.PHONY: override_dh_auto_build-arch
override_dh_auto_build-arch:
	$(MAKE) \
	  TARGET=$(DEB_HOST_GNU_TYPE) \
	  NORMALIZED_TARGET=$(DEB_HOST_GNU_TYPE) \
	  LIBRARY_TYPES='static relocatable' \
	  GNATCOLL_VERSION=$(GNATCOLL_VERSION) \
	  GPRBUILD_OPTIONS='$(BUILDER_OPTIONS) $(foreach v,ADAFLAGS CFLAGS CPPFLAGS LDFLAGS,"-X$(v)=$($(v))")'
override_dh_auto_clean::
	rm -fr lib obj

.PHONY: override_dh_auto_build-indep
override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) -C docs html latexpdf text SPHINXOPTS=-j$(BUILDER_JOBS)
endif
override_dh_auto_clean::
	$(MAKE) -C docs clean

# Ignore upstream install target.
.PHONY: override_dh_auto_install

# Mimic 'dh --with sphinxdoc', but without adding sphinx-common to
# Build-Depends for arch-only builds.
.PHONY: override_dh_installdocs-indep
override_dh_installdocs-indep:
	dh_installdocs -i
	dh_sphinxdoc

## libgnatcoll 19

=== debian/changelog ===
libgnatcoll (19-4) unstable; urgency=medium

  * Reupload to unstable for gnat-9 transition.
  * Use debhelper 12 dh-sequenc syntax.
  * Wrap and sort build dependencies.
  * Standards-Version: 4.5.0.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 25 Feb 2020 15:28:56 +0100

libgnatcoll (19-3) experimental; urgency=medium

  * Use dh-sequence-* syntax for dh-ada-library.
    This also ensures a dh-ada-library updated for libgnatprj.
  * Remove redundant branch selection from Vcs-Git field.
  * Override doc-main-package to silent a warning by dh_installdocs.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 30 Dec 2019 23:32:05 +0100

libgnatcoll (19-2) experimental; urgency=medium

  * Standards-Version 4.4.1.
  * Rebuild against renamed libgpr-dev -> libgnatprj-dev.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 03 Dec 2019 19:43:04 +0100

libgnatcoll (19-1) experimental; urgency=medium

  * New upstream release, built with gnat-9 and updated dependencies.
    Rename library and -dev package accordingly.
  * Move VCS to git and salsa.debian.org.
  * Standards-Version 4.4.0.
  * Forward most patches.
  * GCC-9 implicitly selects --as-needed linker option.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 03 Sep 2019 10:49:22 +0200

=== debian/control ===
--- 
+++ 
@@ -4,31 +4,30 @@
 Maintainer: Nicolas Boulenguez <nicolas@debian.org>
 Build-Depends:
  debhelper-compat (= 12),
- gnat, gnat-8,
+ gnat, gnat-9,
 # This line is parsed to set gnat version.
-# dh-ada-library allowing .ada extension.
- dh-ada-library (>= 6.10),
+ dh-sequence-ada-library,
 # gprbuild building static libraries.
  gprbuild (>= 2018-3),
- libgpr2-dev (>= 2017-5),
+ libgnatprj7-dev,
 # Implicit libc6-dev provides: iconv, syslog.
 Build-Depends-Indep:
+ dh-sequence-sphinxdoc,
+# Sphinx >= 1.6 uses the latexmk driver:
+ latexmk,
  python3-sphinx,
- latexmk,
-# Sphinx >= 1.6 uses the latexmk driver.
+ sphinx-common,
  texlive-fonts-recommended,
+ texlive-latex-extra,
 # sphinx-doc requires iftex.sty:
  texlive-plain-generic,
- texlive-latex-extra
-# dh_sphinxdoc
- ,sphinx-common
 Homepage: https://www.adacore.com/community
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
-Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libgnatcoll
-Vcs-Mtn: mtn://www.ada-france.org?org.debian.libgnatcoll
+Vcs-Browser: https://salsa.debian.org/debian/libgnatcoll
+Vcs-Git: https://salsa.debian.org/debian/libgnatcoll.git
 
-Package: libgnatcoll17-dev
+Package: libgnatcoll18-dev
 # Such lines are parsed to set Ada Library Information versions.
 Section: libdevel
 Architecture: any
@@ -59,7 +58,7 @@
  .
  This package contains the documentation in text, PDF and HTML.
 
-Package: libgnatcoll17
+Package: libgnatcoll18
 # Such lines are parsed to set Shared Object versions.
 Section: libs
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 # Build script for GNATColl in Debian.
-# Copyright (c) 2014-2018 Nicolas Boulenguez <nicolas@debian.org>
+# Copyright (c) 2014-2019 Nicolas Boulenguez <nicolas@debian.org>
 
 # This build script is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License as
@@ -21,14 +21,14 @@
   ' debian/control),$(eval $(line)))
 
 DEB_BUILD_MAINT_OPTIONS := hardening=+all
-DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed -Wl,--no-undefined \
+DEB_LDFLAGS_MAINT_APPEND := -Wl,--no-undefined \
   -Wl,--no-copy-dt-needed-entries -Wl,--no-allow-shlib-undefined
 include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/buildflags.mk
 include /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk
 
 %:
-	dh $@ --with ada-library
+	dh $@
 
 .PHONY: override_dh_auto_clean
 # We can do better than gprclean.
@@ -58,9 +58,8 @@
 # Ignore upstream install target.
 .PHONY: override_dh_auto_install
 
-# Mimic 'dh --with sphinxdoc', but without adding sphinx-common to
-# Build-Depends for arch-only builds.
-.PHONY: override_dh_installdocs-indep
-override_dh_installdocs-indep:
-	dh_installdocs -i
-	dh_sphinxdoc
+# Avoid a warning about doc-main-package.
+.PHONY: override_dh_installdocs
+override_dh_installdocs:
+	dh_installdocs --package=libgnatcoll-doc --doc-main-package=libgnatcoll-doc
+	dh_installdocs --remaining-packages
